#if !defined(_CMATRIX_HEADER_)
#define _CMATRIX_HEADER_


//  츮 ϴ 迭, element[9] Ŀ ġ Ʒ 
//  [  e0  e3  e6  ]
//  [  e1  e4  e7  ]
//  [  e2  e5  e8  ]

class CMatrix3 {
public:
	//   
	CMatrix3();
	CMatrix3(const double rhs[9]);
	CMatrix3(const CMatrix3& rhs);
	//    
	CMatrix3& operator=(const CMatrix3& rhs);
	//   Ҹ
	~CMatrix3()  {}

	//   
	void Identity();
	//  ġ 
	void Transpose();

	//  + ׿
	CMatrix3& operator+();
	//  - ׿
	CMatrix3 operator-() const;
	//   
	CMatrix3 operator+(const CMatrix3& rhs) const;
	CMatrix3& operator+=(const CMatrix3& rhs);
	//   
	CMatrix3 operator-(const CMatrix3& rhs) const;
	CMatrix3& operator-=(const CMatrix3& rhs);
	//   
	CMatrix3 operator*(const CMatrix3& rhs) const;
	CMatrix3& operator*=(const CMatrix3& rhs);

	//  İ Į 
	void Scalar(double k);

	//  Ľ Ѵ
	double Det() const;
	//   Ѵ
	CMatrix3 Inverse() const;

protected:
	//   Ѵ
	CMatrix3 Adjoint() const;

public:
	double element[9];
};


#endif  //  _CMATRIX_HEADER_
